import React from "react";
import { AdaptedFormItemProps, ControlledParams, FormItemSetupParams, LocalParams } from "./useFormTypes";
/**
 * Cases: Required (localvalidation), optional, async validation, custom validation messages
 * local state, global state
 * adaptor for custom form items
 * type check everything after "name"
 *
 * Must implement:
 * - Data type passed in, initial data
 * - create a form item
 * - onBlur for focus then unfocus for "required"
 *
 * Does not support onChange with multiple params
 */
export declare const useForm: <T extends {}>({ values, onChange, }: ControlledParams<T>) => {
    createFormItem: <K extends keyof T, M, A = undefined>(key: K, { adaptor, meta, ...validationParams }?: FormItemSetupParams<T, K, M, A>) => (formItem: (params: AdaptedFormItemProps<T, K, M, A>) => React.ReactNode) => React.ReactNode;
    validate: () => boolean;
};
export declare const useLocalForm: <T>({ initialData }: LocalParams<T>) => {
    getValues: () => T;
    createFormItem: <K extends keyof T, M, A = undefined>(key: K, { adaptor, meta, ...validationParams }?: FormItemSetupParams<T, K, M, A>) => (formItem: (params: AdaptedFormItemProps<T, K, M, A>) => React.ReactNode) => React.ReactNode;
    validate: () => boolean;
};
//# sourceMappingURL=useForm.d.ts.map